#include<iostream>
#include<opencv2/core/core.hpp>
#include<opencv2/highgui/highgui.hpp>
#include<opencv2/imgproc/imgproc.hpp>
#include<opencv2/gpu/gpu.hpp>

using std::cout;
using std::endl;

int main()
{
	//Path of the input image
	std::string path = "D:/images/image.jpg";

	//Read the image from harddisk, into a cv::Mat
	cv::Mat input = cv::imread(path);

	//Check if the image has been read successfully
	if(input.empty())
	{
		cout<<"Image Not Found"<<endl;
		return -1;
	}

	cv::Mat output;

	//Declare the input and output GpuMat
	cv::gpu::GpuMat input_gpu;
	cv::gpu::GpuMat output_gpu;

	//Copy the input cv::Mat to device.
	//Device memory will be allocated automatically according to the parameters of input image
	input_gpu.upload(input);

	//Convert the input image to grayscale on GPU
	cv::gpu::cvtColor(input_gpu,output_gpu,CV_BGR2GRAY);

	//Copy the result from GPU back to host
	output_gpu.download(output);

	//Show the result
	cv::imshow("Grayscale",output);
	cv::waitKey();

	return 0;
}